# generated by datamodel-codegen:
#   filename:  properties_directory/non_scalar/total_energy_contributions.json
#   version:   0.28.5

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import BaseModel, Field


class Name(Enum):
    temperature_entropy = "temperature_entropy"


class ScalarSchema(BaseModel):
    name: Optional[Name] = None
    value: float


class Name186(Enum):
    harris_foulkes = "harris_foulkes"


class ScalarSchema20(BaseModel):
    name: Optional[Name186] = None
    value: float


class Name187(Enum):
    one_electron = "one_electron"


class ScalarSchema21(BaseModel):
    name: Optional[Name187] = None
    value: float


class Name188(Enum):
    hartree = "hartree"


class ScalarSchema22(BaseModel):
    name: Optional[Name188] = None
    value: float


class Name189(Enum):
    exchange = "exchange"


class ScalarSchema23(BaseModel):
    name: Optional[Name189] = None
    value: float


class Name190(Enum):
    exchange_correlation = "exchange_correlation"


class ScalarSchema24(BaseModel):
    name: Optional[Name190] = None
    value: float


class Name191(Enum):
    ewald = "ewald"


class ScalarSchema25(BaseModel):
    name: Optional[Name191] = None
    value: float


class Name192(Enum):
    alphaZ = "alphaZ"


class ScalarSchema26(BaseModel):
    name: Optional[Name192] = None
    value: float


class Name193(Enum):
    atomic_energy = "atomic_energy"


class ScalarSchema27(BaseModel):
    name: Optional[Name193] = None
    value: float


class Name194(Enum):
    eigenvalues = "eigenvalues"


class ScalarSchema28(BaseModel):
    name: Optional[Name194] = None
    value: float


class Name195(Enum):
    PAW_double_counting_correction_2 = "PAW_double-counting_correction_2"


class ScalarSchema29(BaseModel):
    name: Optional[Name195] = None
    value: float


class Name196(Enum):
    PAW_double_counting_correction_3 = "PAW_double-counting_correction_3"


class ScalarSchema30(BaseModel):
    name: Optional[Name196] = None
    value: float


class Name197(Enum):
    hartree_fock = "hartree_fock"


class ScalarSchema31(BaseModel):
    name: Optional[Name197] = None
    value: float


class Name198(Enum):
    total_energy_contributions = "total_energy_contributions"


class Units(Enum):
    kJ_mol = "kJ/mol"
    eV = "eV"
    J_mol = "J/mol"
    hartree = "hartree"
    cm_1 = "cm-1"
    Ry = "Ry"
    eV_atom = "eV/atom"


class TotalEnergyContributionsSchema(BaseModel):
    temperatureEntropy: Optional[ScalarSchema] = Field(None, title="scalar schema")
    """
    product of temperature and configurational entropy
    """
    harrisFoulkes: Optional[ScalarSchema20] = Field(None, title="scalar schema")
    """
    non self-consitent energy based on an input charge density
    """
    oneElectron: Optional[ScalarSchema21] = Field(None, title="scalar schema")
    """
    kinetic + pseudopotential energy
    """
    hartree: Optional[ScalarSchema22] = Field(None, title="scalar schema")
    """
    energy due to coulomb potential
    """
    exchange: Optional[ScalarSchema23] = Field(None, title="scalar schema")
    """
    exchange energy
    """
    exchangeCorrelation: Optional[ScalarSchema24] = Field(None, title="scalar schema")
    """
    exchange and correlation energy per particle
    """
    ewald: Optional[ScalarSchema25] = Field(None, title="scalar schema")
    """
    summation of interaction energies at long length scales due to coloumbic interactions
    """
    alphaZ: Optional[ScalarSchema26] = Field(None, title="scalar schema")
    """
    divergent electrostatic ion interaction in compensating electron gas
    """
    atomicEnergy: Optional[ScalarSchema27] = Field(None, title="scalar schema")
    """
    kinetic energy of wavefunctions in the atomic limit
    """
    eigenvalues: Optional[ScalarSchema28] = Field(None, title="scalar schema")
    """
    sum of one electron energies of kinetic, electrostatic, and exchange correlation
    """
    PAWDoubleCounting2: Optional[ScalarSchema29] = Field(None, title="scalar schema")
    """
    double counting correction 2
    """
    PAWDoubleCounting3: Optional[ScalarSchema30] = Field(None, title="scalar schema")
    """
    double counting correction 3
    """
    hartreeFock: Optional[ScalarSchema31] = Field(None, title="scalar schema")
    """
    hartree-fock contribution
    """
    name: Optional[Name198] = None
    units: Optional[Units] = None
